<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: /home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/sdio_layer.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/sdio_layer.h</h1><div class="fragment"><pre>00001 <span class="comment">/*</span>
00002 <span class="comment"> * Internal/private definitions.</span>
00003 <span class="comment"> *</span>
00004 <span class="comment"> * Copyright (C) 2007 Cambridge Silicon Radio Ltd.</span>
00005 <span class="comment"> *</span>
00006 <span class="comment"> * Refer to LICENSE.txt included with this source code for details on</span>
00007 <span class="comment"> * the license terms.</span>
00008 <span class="comment"> */</span>
00009 <span class="preprocessor">#ifndef _SDIO_LAYER_H</span>
00010 <span class="preprocessor"></span><span class="preprocessor">#define _SDIO_LAYER_H</span>
00011 <span class="preprocessor"></span>
00012 <span class="preprocessor">#include &lt;oska/all.h&gt;</span>
00013 
00014 <span class="preprocessor">#include &lt;sdioemb/sdio.h&gt;</span>
00015 <span class="preprocessor">#include &lt;sdioemb/sdio_api.h&gt;</span>
00016 <span class="preprocessor">#include &lt;sdioemb/slot_api.h&gt;</span>
00017 
00018 <span class="preprocessor">#include "sdio_event_log.h"</span>
00019 <span class="preprocessor">#include "sdio_config.h"</span>
00020 
00021 <span class="preprocessor">#define SDD_MAX_FUNCTIONS (SDIO_MAX_FUNCTIONS + 1) </span><span class="comment">/* extra for uif function */</span>
00022 
00023 <span class="keyword">struct </span>sdio_slot_priv {
00024     <span class="keywordtype">int</span> id;
00025 
00026     <span class="keywordtype">unsigned</span> card_present:1;
00027     <span class="keywordtype">unsigned</span> card_powered:1;
00028 
00029     <span class="keywordtype">int</span> num_functions;
00030     <span class="keyword">struct </span><a class="code" href="structsdio__dev.html">sdio_dev</a> *functions[SDD_MAX_FUNCTIONS];
00031     <span class="keywordtype">int</span> max_bus_width;
00032     <span class="keywordtype">int</span> max_card_freq;
00033     <span class="keywordtype">int</span> current_clock_freq;
00034     <span class="keywordtype">unsigned</span> supports_high_speed:1;
00035 
00036     <span class="keyword">struct </span><a class="code" href="structsdio__card__io__ops.html">sdio_card_io_ops</a> io_ops;
00037 
00038     os_spinlock_t lock;
00039 
00040     <span class="keywordtype">unsigned</span> active;
00041     <span class="keywordtype">unsigned</span> power;
00042     <span class="keywordtype">unsigned</span> int_enabled;
00043 
00044     <span class="keywordtype">int</span> busy;
00045     <span class="keywordtype">int</span> last_function;
00046 <span class="preprocessor">#if SDD_CARD_IS_REMOVABLE</span>
00047 <span class="preprocessor"></span>    os_thread_t card_detect_thread;
00048 <span class="preprocessor">#endif</span>
00049 <span class="preprocessor"></span>    os_mutex_t card_mutex;
00050 
00051 <span class="preprocessor">#ifdef SDD_DEBUG_EVENT_LOG</span>
00052 <span class="preprocessor"></span>    <span class="keyword">struct </span>sdio_event_log event_log;
00053 <span class="preprocessor">#endif</span>
00054 <span class="preprocessor"></span>};
00055 
00056 <span class="keyword">struct </span>sdio_dev_priv {
00057     <span class="keyword">struct </span><a class="code" href="structsdio__slot.html">sdio_slot</a> *slot;
00058     uint32_t cis_ptr;
00059     <span class="keywordtype">int</span> max_freq;
00060     <span class="keyword">struct </span><a class="code" href="structsdio__cmd.html">sdio_cmd</a> *queued_cmd;
00061 };
00062 
00063 <span class="keywordtype">void</span> slot_error(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">const</span> <span class="keywordtype">char</span> *fmt, ...);
00064 <span class="keywordtype">void</span> slot_warning(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">const</span> <span class="keywordtype">char</span> *fmt, ...);
00065 <span class="keywordtype">void</span> slot_info(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">const</span> <span class="keywordtype">char</span> *fmt, ...);
00066 <span class="keywordtype">void</span> slot_debug(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">const</span> <span class="keywordtype">char</span> *fmt, ...);
00067 
00068 <span class="keywordtype">void</span> sdio_core_init(<span class="keywordtype">void</span>);
00069 <span class="keyword">struct </span><a class="code" href="structsdio__dev.html">sdio_dev</a> *sdio_dev_alloc(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> func);
00070 <span class="keywordtype">void</span> sdio_dev_free(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00071 <span class="keywordtype">int</span> sdio_dev_add(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00072 <span class="keywordtype">void</span> sdio_dev_del(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00073 
00074 <span class="keywordtype">int</span> sdio_card_detect_init(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00075 <span class="keywordtype">void</span> sdio_card_detect_exit(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00076 <span class="keywordtype">int</span> sdio_card_start(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00077 <span class="keywordtype">void</span> sdio_card_stop(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00078 <span class="keywordtype">void</span> sdio_card_configure(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00079 
00080 <span class="keywordtype">int</span> slot_start_cmd(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keyword">struct</span> <a class="code" href="structsdio__cmd.html">sdio_cmd</a> *cmd);
00081 <span class="keywordtype">void</span> slot_set_max_bus_freq(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> freq);
00082 <span class="keywordtype">void</span> slot_set_bus_freq(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> freq);
00083 <span class="keywordtype">int</span> slot_set_bus_width(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, <span class="keywordtype">int</span> bus_width);
00084 
00085 <span class="keywordtype">int</span> sdio_func_set_block_size(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> blksz);
00086 <span class="keywordtype">void</span> sdio_func_set_max_bus_freq(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> max_freq);
00087 
00088 <span class="keywordtype">int</span> sdio_cis_read_ptr_reg(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, uint32_t addr, uint32_t *ptr);
00089 
00090 <span class="keywordtype">int</span> sdio_raw_cmd(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, uint8_t cmd_id, uint32_t arg, <span class="keywordtype">unsigned</span> flags,
00091                  <span class="keyword">union</span> <a class="code" href="unionsdio__response.html">sdio_response</a> *response);
00092 <span class="keywordtype">int</span> cspi_raw_word_cmd(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot, uint8_t cmd_id, uint32_t addr, uint16_t *word);
00093 
00094 <span class="keywordtype">int</span> sdio_io_read8(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t *data);
00095 <span class="keywordtype">int</span> sdio_io_write8(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t data);
00096 <span class="keywordtype">int</span> sdio_io_read(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t *data, size_t len);
00097 <span class="keywordtype">int</span> sdio_io_write(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, <span class="keyword">const</span> uint8_t *data, size_t len);
00098 
00099 <span class="keywordtype">int</span> cspi_io_read8(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t *data);
00100 <span class="keywordtype">int</span> cspi_io_write8(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t data);
00101 <span class="keywordtype">int</span> cspi_io_read(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, uint8_t *data, size_t len);
00102 <span class="keywordtype">int</span> cspi_io_write(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev, <span class="keywordtype">int</span> func, uint32_t addr, <span class="keyword">const</span> uint8_t *data, size_t len);
00103 
00104 <span class="keywordtype">int</span> cspi_is_enabled(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00105 <span class="keywordtype">int</span> cspi_card_init(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00106 <span class="keywordtype">int</span> cspi_enable(<span class="keyword">struct</span> <a class="code" href="structsdio__slot.html">sdio_slot</a> *slot);
00107 
00108 <span class="keyword">extern</span> <span class="keywordtype">int</span> sdd_card_poll_interval_ms;
00109 <span class="keyword">extern</span> <span class="keywordtype">int</span> sdd_max_bus_freq;
00110 <span class="keyword">extern</span> <span class="keywordtype">int</span> sdd_max_block_size;
00111 
00112 <span class="keyword">extern</span> os_mutex_t sdio_core_mutex;
00113 
00114 <span class="comment">/*</span>
00115 <span class="comment"> * Hooks for managing OS-specific device structures.</span>
00116 <span class="comment"> */</span>
00117 <span class="keywordtype">int</span> sdio_os_dev_add(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00118 <span class="keywordtype">void</span> sdio_os_dev_del(<span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00119 
00120 <span class="preprocessor">#endif </span><span class="comment">/* #ifndef _SDIO_LAYER_H */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
